diff -urN gcc-3.3.3.orig/libffi/src/pa/linux.S gcc-3.3.3/libffi/src/pa/linux.S
--- gcc-3.3.3.orig/libffi/src/pa/linux.S	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/libffi/src/pa/linux.S	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,310 @@
+/* -----------------------------------------------------------------------
+   linux.S - (c) 2003 Randolph Chung <tausq@debian.org>
+
+   HPPA Foreign Function Interface
+
+   Permission is hereby granted, free of charge, to any person obtaining
+   a copy of this software and associated documentation files (the
+   ``Software''), to deal in the Software without restriction, including
+   without limitation the rights to use, copy, modify, merge, publish,
+   distribute, sublicense, and/or sell copies of the Software, and to
+   permit persons to whom the Software is furnished to do so, subject to
+   the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED ``AS IS'', WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+   IN NO EVENT SHALL CYGNUS SOLUTIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR
+   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+   OTHER DEALINGS IN THE SOFTWARE.
+   ----------------------------------------------------------------------- */
+
+#define LIBFFI_ASM
+#include <fficonfig.h>
+#include <ffi.h>
+
+#define FFI_TYPE_SMALL_STRUCT1 -1
+#define FFI_TYPE_SMALL_STRUCT2 -2
+
+	.text
+	.align 4
+
+	/* void ffi_call_LINUX(void (*)(char *, extended_cif *),
+			       extended_cif *ecif,
+			       unsigned bytes,
+			       unsigned flags,
+			       unsigned *rvalue,
+			       void (*fn)());
+	 */
+
+	.export ffi_call_LINUX,code
+	.import ffi_prep_args_LINUX,code
+
+	.type ffi_call_LINUX, @function
+.LFB1:
+ffi_call_LINUX:
+	.proc
+	.callinfo FRAME=64,CALLS,SAVE_RP,SAVE_SP,ENTRY_GR=4
+	.entry
+	stw %rp, -20(%sp)
+	copy %r3, %r1
+.LCFI11:
+
+	copy %sp, %r3
+.LCFI12:
+
+	/* Setup the stack for calling prep_args...
+	   We want the stack to look like this:
+
+	   [ Previous stack                            ] <- %r3
+
+	   [ 64-bytes register save area               ] <- %r4
+
+	   [ Stack space for actual call, passed as    ] <- %arg0
+	   [     arg0 to ffi_prep_args_LINUX           ]
+
+	   [ Stack for calling prep_args               ] <- %sp
+	 */
+
+	stwm %r1, 64(%sp)
+	stw %r4, 12(%r3)
+.LCFI13:
+	copy %sp, %r4
+
+	addl %arg2, %r4, %arg0                  /* arg stack */
+	stw %arg3, -48(%r3)                     /* save flags; we need it later */
+
+	/* Call prep_args:
+	   %arg0(stack) -- set up above
+	   %arg1(ecif) -- same as incoming param
+	   %arg2(bytes) -- same as incoming param */
+	bl ffi_prep_args_LINUX,%r2
+	ldo 64(%arg0), %sp
+	ldo -64(%sp), %sp
+
+	/* now %sp should point where %arg0 was pointing */
+
+	/* Load the arguments that should be passed in registers */
+	/* The fp args were loaded by the prep_args function */
+	ldw -36(%sp), %arg0
+	ldw -40(%sp), %arg1
+	ldw -44(%sp), %arg2
+	ldw -48(%sp), %arg3
+
+	/* in case the function is going to return a structure
+	 * we need to give it a place to put the result...
+	 */
+	ldw -52(%r3), %ret0                     /* %ret0 <- rvalue */
+	ldw -56(%r3), %r22                      /* %r22 <- function to call */
+	bl $$dyncall, %r31                      /* Call the user function */
+	copy %r31, %rp
+
+	/* Prepare to store the result; we need to recover flags and rvalue */
+	ldw -48(%r3), %r21                      /* r21 <- flags */
+	ldw -52(%r3), %r20                      /* r20 <- rvalue */
+
+	/* Store the result according to the return type... */
+
+checksmst1:
+	comib,<>,n FFI_TYPE_SMALL_STRUCT1, %r21, checksmst2
+	/* There is maybe a better way to handle 3 byte structs.  */
+	SH2ADD %ret0,0,%ret0
+	SH2ADD %ret0,0,%ret0
+	SH2ADD %ret0,0,%ret0
+	SH2ADD %ret0,0,%ret0
+	b done
+	stw %ret0, 0(%r20)
+
+checksmst2:
+	comib,<>,n FFI_TYPE_SMALL_STRUCT2, %r21, checkint8
+	/* Up to now I don't have a way to handle 6/7 byte structs.
+	   The values are left bounded in the registers. In the struct
+	   itself they are left bounded.  */
+	stw %ret0, 0(%r20)
+	b done
+	stw %ret1, 4(%r20)
+
+checkint8:
+	comib,<>,n FFI_TYPE_UINT8, %r21, checkint16
+	b done
+	stb %ret0, 0(%r20)
+
+checkint16:
+	comib,<>,n FFI_TYPE_UINT16, %r21, checkint32
+	b done
+	sth %ret0, 0(%r20)
+
+checkint32:
+	comib,<>,n FFI_TYPE_UINT32, %r21, checkint
+	b done
+	stw %ret0, 0(%r20)
+
+checkint:
+	comib,<>,n FFI_TYPE_INT, %r21, checkll
+	b done
+	stw %ret0, 0(%r20)
+
+checkll:
+	comib,<>,n FFI_TYPE_UINT64, %r21, checkdbl
+	stw %ret0, 0(%r20)
+	b done
+	stw %ret1, 4(%r20)
+
+checkdbl:
+	comib,<>,n FFI_TYPE_DOUBLE, %r21, checkfloat
+	b done
+	fstd %fr4,0(%r20)
+
+checkfloat:
+	comib,<>,n FFI_TYPE_FLOAT, %r21, done
+	fstw %fr4L,0(%r20)
+
+	/* structure returns are either handled by one of the
+	 * INT/UINT64 cases above, or, if passed by pointer,
+	 * is handled by the callee
+	 */
+
+done:
+	/* all done, return */
+	copy %r4, %sp                           /* pop arg stack */
+	ldw 12(%r3), %r4
+	ldwm -64(%sp), %r3                      /* .. and pop stack */
+	ldw -20(%sp), %rp
+	bv %r0(%rp)
+	nop
+	.exit
+	.procend
+.LFE1:
+
+	/* void ffi_closure_LINUX(void);
+	 * Called with closure argument in %r21
+	 */
+	.export ffi_closure_LINUX,code
+	.import ffi_closure_inner_LINUX,code
+
+	.type ffi_closure_LINUX, @function
+.LFB2:
+ffi_closure_LINUX:
+	.proc
+	.callinfo FRAME=64,CALLS,SAVE_RP,SAVE_SP,ENTRY_GR=3
+	.entry
+
+	stw %rp, -20(%sp)
+.LCFI20:
+	copy %r3, %r1
+.LCFI21:
+	copy %sp, %r3
+.LCFI22:
+	stwm %r1, 64(%sp)
+
+	/* Put arguments onto the stack and call ffi_closure_inner */
+	stw %arg0, -36(%r3)
+	stw %arg1, -40(%r3)
+	stw %arg2, -44(%r3)
+	stw %arg3, -48(%r3)
+
+	copy %r21, %arg0
+	bl ffi_closure_inner_LINUX, %r2
+	copy %r3, %arg1
+
+	ldwm -64(%sp), %r3
+	ldw -20(%sp), %rp
+	ldw -36(%sp), %ret0
+	bv %r0(%r2)
+	ldw -40(%sp), %ret1
+
+	.exit
+	.procend
+.LFE2:
+
+	.section        ".eh_frame",EH_FRAME_FLAGS,@progbits
+.Lframe1:
+	.word   .LECIE1-.LSCIE1 ;# Length of Common Information Entry
+.LSCIE1:
+	.word   0x0     ;# CIE Identifier Tag
+	.byte   0x1     ;# CIE Version
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.ascii "zR\0"   ;# CIE Augmentation
+#else
+	.ascii "\0"     ;# CIE Augmentation
+#endif
+	.uleb128 0x1    ;# CIE Code Alignment Factor
+	.sleb128 4      ;# CIE Data Alignment Factor
+	.byte   0x2     ;# CIE RA Column
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.uleb128  0x1   ;# Augmentation size
+	.byte	0x1b    ;# FDE Encoding (pcrel sdata4)
+#endif
+	.byte   0xc     ;# DW_CFA_def_cfa
+	.uleb128 0x1e
+	.uleb128 0x0
+	.align 4
+.LECIE1:
+.LSFDE1:
+	.word   .LEFDE1-.LASFDE1        ;# FDE Length
+.LASFDE1:
+	.word   .LASFDE1-.Lframe1       ;# FDE CIE offset
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.word   .LFB1-. ;# FDE initial location
+#else
+	.word   .LFB1   ;# FDE initial location
+#endif
+	.word   .LFE1-.LFB1     ;# FDE address range
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.uleb128 0x0    ;# Augmentation size
+#endif
+
+	.byte   0x4     ;# DW_CFA_advance_loc4
+	.word   .LCFI11-.LFB1
+	.byte	0x83	;# DW_CFA_offset, column 0x3
+	.uleb128 0x0
+	.byte   0x11    ;# DW_CFA_offset_extended_sf; save r2 at [r30-20]
+	.uleb128 0x2
+	.sleb128 -5
+
+	.byte   0x4     ;# DW_CFA_advance_loc4
+	.word   .LCFI12-.LCFI11
+	.byte   0xd     ;# DW_CFA_def_cfa_register = r3
+	.uleb128 0x3
+
+	.byte   0x4     ;# DW_CFA_advance_loc4
+	.word   .LCFI13-.LCFI12
+	.byte	0x84	;# DW_CFA_offset, column 0x4
+	.uleb128 0x3
+
+	.align 4
+.LEFDE1:
+
+.LSFDE2:
+	.word   .LEFDE2-.LASFDE2        ;# FDE Length
+.LASFDE2:
+	.word   .LASFDE2-.Lframe1       ;# FDE CIE offset
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.word   .LFB2-. ;# FDE initial location
+#else
+	.word   .LFB2   ;# FDE initial location
+#endif
+	.word   .LFE2-.LFB2     ;# FDE address range
+#if 0 // defined _RELOCATABLE || defined __PIC__
+	.uleb128 0x0    ;# Augmentation size
+#endif
+	.byte   0x4     ;# DW_CFA_advance_loc4
+	.word   .LCFI21-.LFB2
+	.byte   0x83    ;# DW_CFA_offset, column 0x3
+	.uleb128 0x0
+	.byte   0x11    ;# DW_CFA_offset_extended_sf
+	.uleb128 0x2
+	.sleb128 -5
+
+	.byte   0x4     ;# DW_CFA_advance_loc4
+	.word   .LCFI12-.LCFI11
+	.byte   0xd     ;# DW_CFA_def_cfa_register = r3
+	.uleb128 0x3
+
+	.align 4
+.LEFDE2:
+
diff -urN gcc-3.3.3.orig/libffi/src/prep_cif.c gcc-3.3.3/libffi/src/prep_cif.c
--- gcc-3.3.3.orig/libffi/src/prep_cif.c	2002-09-30 05:59:42.000000000 -0600
+++ gcc-3.3.3/libffi/src/prep_cif.c	2004-04-20 02:29:00.000000000 -0600
@@ -104,7 +104,7 @@
   FFI_ASSERT(ffi_type_test(cif->rtype));
 
   /* x86-64 and s390 stack space allocation is handled in prep_machdep.  */
-#if !defined M68K && !defined __x86_64__ && !defined S390
+#if !defined M68K && !defined __x86_64__ && !defined S390 && !defined PA
   /* Make space for the return structure pointer */
   if (cif->rtype->type == FFI_TYPE_STRUCT
 #ifdef SPARC
@@ -123,7 +123,7 @@
       if (((*ptr)->size == 0) && (initialize_aggregate((*ptr)) != FFI_OK))
 	return FFI_BAD_TYPEDEF;
 
-#if !defined __x86_64__ && !defined S390
+#if !defined __x86_64__ && !defined S390 && !defined PA
 #ifdef SPARC
       if (((*ptr)->type == FFI_TYPE_STRUCT
 	   && ((*ptr)->size > 16 || cif->abi != FFI_V9))
diff -urN gcc-3.3.3.orig/libjava/Makefile.am gcc-3.3.3/libjava/Makefile.am
--- gcc-3.3.3.orig/libjava/Makefile.am	2003-03-01 15:57:52.000000000 -0700
+++ gcc-3.3.3/libjava/Makefile.am	2004-04-20 02:29:00.000000000 -0600
@@ -106,6 +106,8 @@
 
 ## ################################################################
 
+rpath_def = $(shell if test "$(toolexeclibdir)" != /usr/lib -a test "$(toolexeclibdir)" != /usr/lib/.; then echo -rpath $(toolexeclibdir); fi)
+
 ##
 ## How to build libgcj.a and libgcj.jar
 ##
@@ -472,7 +474,7 @@
 ## need this because we are explicitly using libtool to link using the
 ## `.la' file.
 jv_convert_LDFLAGS = --main=gnu.gcj.convert.Convert \
-	-rpath $(toolexeclibdir) -shared-libgcc $(THREADLDFLAGS)
+	$(rpath_def) -shared-libgcc $(THREADLDFLAGS)
 jv_convert_LINK = $(GCJLINK)
 ## We don't explicitly link in the libraries we need; libgcj.la brings
 ## in all dependencies.  We need the -L so that gcj can find libgcj
@@ -491,7 +493,7 @@
 ## We need -nodefaultlibs because we want to avoid gcj's `-lgcj'.  We
 ## need this because we are explicitly using libtool to link using the
 ## `.la' file.
-gij_LDFLAGS = -rpath $(toolexeclibdir) -shared-libgcc $(THREADLDFLAGS)
+gij_LDFLAGS = $(rpath_def) -shared-libgcc $(THREADLDFLAGS)
 gij_LINK = $(GCJLINK)
 ## See jv_convert_LDADD.
 gij_LDADD = -L$(here)/.libs libgcj.la
@@ -503,7 +505,7 @@
 ## This is a dummy definition.
 EXTRA_rmic_SOURCES = $(rmi_java_source_files)
 rmic_LDFLAGS = --main=gnu.java.rmi.rmic.RMIC \
-	-rpath $(toolexeclibdir) -shared-libgcc $(THREADLDFLAGS)
+	$(rpath_def) -shared-libgcc $(THREADLDFLAGS)
 rmic_LINK = $(GCJLINK)
 ## See jv_convert_LDADD.
 rmic_LDADD = -L$(here)/.libs libgcj.la
@@ -515,7 +517,7 @@
 ## This is a dummy definition.
 EXTRA_rmiregistry_SOURCES = $(rmi_java_source_files)
 rmiregistry_LDFLAGS = --main=gnu.java.rmi.registry.RegistryImpl \
-	-rpath $(toolexeclibdir) -shared-libgcc $(THREADLDFLAGS)
+	$(rpath_def) -shared-libgcc $(THREADLDFLAGS)
 rmiregistry_LINK = $(GCJLINK)
 ## See jv_convert_LDADD.
 rmiregistry_LDADD = -L$(here)/.libs libgcj.la
diff -urN gcc-3.3.3.orig/libjava/configure.host gcc-3.3.3/libjava/configure.host
--- gcc-3.3.3.orig/libjava/configure.host	2003-02-12 19:09:26.000000000 -0700
+++ gcc-3.3.3/libjava/configure.host	2004-04-20 02:29:00.000000000 -0600
@@ -112,6 +112,11 @@
 	enable_hash_synchronization_default=yes
 	IEEESPEC=-mieee
 	;;
+  hppa-*)
+	sysdeps_dir=pa
+	libgcj_interpreter=yes
+	enable_hash_synchronization_default=yes
+	;;
   powerpc64*-*)
 	# libffi not ported.
 	with_libffi_default=no
diff -urN gcc-3.3.3.orig/libjava/configure.in gcc-3.3.3/libjava/configure.in
--- gcc-3.3.3.orig/libjava/configure.in	2003-06-17 10:04:20.000000000 -0600
+++ gcc-3.3.3/libjava/configure.in	2004-04-20 02:29:00.000000000 -0600
@@ -805,7 +805,11 @@
   toolexecdir='$(libdir)/gcc-lib/$(target_alias)'
   toolexecmainlibdir='$(libdir)'
 fi
-toolexeclibdir=$toolexecmainlibdir/`$CC -print-multi-os-directory`
+multi_os_directory=`$CC -print-multi-os-directory`
+case $multi_os_directory in
+  .) toolexeclibdir=$toolexecmainlibdir ;; # Avoid trailing /.
+  *) toolexeclibdir=$toolexecmainlibdir/$multi_os_directory ;;
+esac
 AC_SUBST(toolexecdir)
 AC_SUBST(toolexecmainlibdir)
 AC_SUBST(toolexeclibdir)
diff -urN gcc-3.3.3.orig/libjava/libltdl/config.h.in gcc-3.3.3/libjava/libltdl/config.h.in
--- gcc-3.3.3.orig/libjava/libltdl/config.h.in	2000-09-10 02:04:40.000000000 -0600
+++ gcc-3.3.3/libjava/libltdl/config.h.in	2004-04-20 02:29:02.000000000 -0600
@@ -1,4 +1,4 @@
-/* config.h.in.  Generated automatically from configure.in by autoheader.  */
+/* config.h.in.  Generated automatically from configure.in by autoheader 2.13.  */
 
 /* Define to empty if the keyword does not work.  */
 #undef const
diff -urN gcc-3.3.3.orig/libjava/sysdep/pa/locks.h gcc-3.3.3/libjava/sysdep/pa/locks.h
--- gcc-3.3.3.orig/libjava/sysdep/pa/locks.h	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/libjava/sysdep/pa/locks.h	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,78 @@
+// locks.h - Thread synchronization primitives. PARISC implementation.
+
+/* Copyright (C) 2002  Free Software Foundation
+
+   This file is part of libgcj.
+
+This software is copyrighted work licensed under the terms of the
+Libgcj License.  Please consult the file "LIBGCJ_LICENSE" for
+details.  */
+
+#ifndef __SYSDEP_LOCKS_H__
+#define __SYSDEP_LOCKS_H__
+
+typedef size_t obj_addr_t;	/* Integer type big enough for object	*/
+				/* address.				*/
+
+// Atomically replace *addr by new_val if it was initially equal to old.
+// Return true if the comparison succeeded.
+// Assumed to have acquire semantics, i.e. later memory operations
+// cannot execute before the compare_and_swap finishes.
+inline static bool
+compare_and_swap(volatile obj_addr_t *addr,
+	 	 obj_addr_t old,
+		 obj_addr_t new_val) 
+{
+  /* FIXME: not atomic */
+  obj_addr_t prev;
+
+  if ((prev = *addr) == old)
+    {
+      *addr = new_val;
+      return true;
+    }
+  else
+    {
+      return false;
+    }
+}
+
+// Set *addr to new_val with release semantics, i.e. making sure
+// that prior loads and stores complete before this
+// assignment.
+inline static void
+release_set(volatile obj_addr_t *addr, obj_addr_t new_val)
+{
+  __asm__ __volatile__(" " : : : "memory");
+  *(addr) = new_val;
+}
+
+// Compare_and_swap with release semantics instead of acquire semantics.
+// On many architecture, the operation makes both guarantees, so the
+// implementation can be the same.
+inline static bool
+compare_and_swap_release(volatile obj_addr_t *addr,
+	 				             obj_addr_t old,
+						     obj_addr_t new_val) 
+{
+  return compare_and_swap(addr, old, new_val);
+}
+
+// Ensure that subsequent instructions do not execute on stale
+// data that was loaded from memory before the barrier.
+inline static void
+read_barrier()
+{
+  __asm__ __volatile__(" " : : : "memory");
+}
+
+// Ensure that prior stores to memory are completed with respect to other
+// processors.
+inline static void
+write_barrier()
+{
+  __asm__ __volatile__(" " : : : "memory");
+}
+
+#endif
+
diff -urN gcc-3.3.3.orig/libobjc/ChangeLog gcc-3.3.3/libobjc/ChangeLog
--- gcc-3.3.3.orig/libobjc/ChangeLog	2004-02-14 13:20:25.000000000 -0700
+++ gcc-3.3.3/libobjc/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,10 @@
+2004-03-02  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	PR bootstrap/14348
+	Backport
+	2003-10-20  Joseph S. Myers  <jsm@polyomino.org.uk>
+	* objc/hash.h (hash_string): Don't use a cast as an lvalue.
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
diff -urN gcc-3.3.3.orig/libobjc/objc/hash.h gcc-3.3.3/libobjc/objc/hash.h
--- gcc-3.3.3.orig/libobjc/objc/hash.h	2002-07-02 13:43:02.000000000 -0600
+++ gcc-3.3.3/libobjc/objc/hash.h	2004-04-20 02:29:00.000000000 -0600
@@ -172,10 +172,10 @@
 {
   unsigned int ret = 0;
   unsigned int ctr = 0;
+  const char *ckey = key;
         
-        
-  while (*(char *) key) {
-    ret ^= *(char *) key++ << ctr;
+  while (*ckey) {
+    ret ^= *ckey++ << ctr;
     ctr = (ctr + 1) % sizeof (void *);
   }
 
diff -urN gcc-3.3.3.orig/libstdc++-v3/ChangeLog gcc-3.3.3/libstdc++-v3/ChangeLog
--- gcc-3.3.3.orig/libstdc++-v3/ChangeLog	2004-02-14 13:20:34.000000000 -0700
+++ gcc-3.3.3/libstdc++-v3/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,10 @@
+2004-02-22  Paolo Carlini  <pcarlini@suse.de>
+
+	PR libstdc++/14220
+	* include/bits/locale_facets.tcc (num_put<>::_M_convert_float):
+	Don't clip the precision passed down to __convert_from_v:
+	22.2.2.2.2 nowhere says so.
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
diff -urN gcc-3.3.3.orig/libstdc++-v3/acinclude.m4 gcc-3.3.3/libstdc++-v3/acinclude.m4
--- gcc-3.3.3.orig/libstdc++-v3/acinclude.m4	2003-09-10 21:08:35.000000000 -0600
+++ gcc-3.3.3/libstdc++-v3/acinclude.m4	2004-04-20 02:29:00.000000000 -0600
@@ -1968,7 +1968,11 @@
     glibcpp_toolexecdir='$(libdir)/gcc-lib/$(target_alias)'
     glibcpp_toolexeclibdir='$(libdir)'
   fi
-  glibcpp_toolexeclibdir=$glibcpp_toolexeclibdir/`$CC -print-multi-os-directory`
+  multi_os_directory=`$CC -print-multi-os-directory`
+  case $multi_os_directory in
+  .) ;; # Avoid trailing /.
+  *) glibcpp_toolexeclibdir=$glibcpp_toolexeclibdir/$multi_os_directory ;;
+  esac
 fi
 
 AC_MSG_CHECKING([for install location])
diff -urN gcc-3.3.3.orig/libstdc++-v3/config.h.in gcc-3.3.3/libstdc++-v3/config.h.in
--- gcc-3.3.3.orig/libstdc++-v3/config.h.in	2003-05-01 12:36:17.000000000 -0600
+++ gcc-3.3.3/libstdc++-v3/config.h.in	2004-04-20 02:29:04.000000000 -0600
@@ -1,4 +1,4 @@
-/* config.h.in.  Generated automatically from configure.in by autoheader.  */
+/* config.h.in.  Generated automatically from configure.in by autoheader 2.13.  */
 
 /* Define if you have a working `mmap' system call.  */
 #undef HAVE_MMAP
diff -urN gcc-3.3.3.orig/libstdc++-v3/include/bits/c++config gcc-3.3.3/libstdc++-v3/include/bits/c++config
--- gcc-3.3.3.orig/libstdc++-v3/include/bits/c++config	2004-02-13 17:16:10.000000000 -0700
+++ gcc-3.3.3/libstdc++-v3/include/bits/c++config	2004-04-20 02:29:00.000000000 -0600
@@ -35,7 +35,7 @@
 #include <bits/os_defines.h>
 
 // The current version of the C++ library in compressed ISO date format.
-#define __GLIBCPP__ 20040214
+#define __GLIBCPP__ 20040401
 
 // This is necessary until GCC supports separate template compilation.
 #define _GLIBCPP_NO_TEMPLATE_EXPORT 1
diff -urN gcc-3.3.3.orig/libstdc++-v3/include/bits/locale_facets.tcc gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc
--- gcc-3.3.3.orig/libstdc++-v3/include/bits/locale_facets.tcc	2004-01-28 19:52:24.000000000 -0700
+++ gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc	2004-04-20 02:29:00.000000000 -0600
@@ -884,22 +884,13 @@
       _M_convert_float(_OutIter __s, ios_base& __io, _CharT __fill, char __mod,
 		       _ValueT __v) const
       {
-	// Note: digits10 is rounded down: add 1 to ensure the maximum
-	// available precision.  Then, in general, one more 1 needs to
-	// be added since, when the %{g,G} conversion specifiers are
-	// chosen inside _S_format_float, the precision field is "the
-	// maximum number of significant digits", *not* the "number of
-	// digits to appear after the decimal point", as happens for
-	// %{e,E,f,F} (C99, 7.19.6.1,4).
-	const int __max_digits = numeric_limits<_ValueT>::digits10 + 2;
-
 	// Use default precision if out of range.
 	streamsize __prec = __io.precision();
-	if (__prec > static_cast<streamsize>(__max_digits))
-	  __prec = static_cast<streamsize>(__max_digits);
-	else if (__prec < static_cast<streamsize>(0))
+	if (__prec < static_cast<streamsize>(0))
 	  __prec = static_cast<streamsize>(6);
 
+	const int __max_digits = numeric_limits<_ValueT>::digits10;	
+
 	typedef numpunct<_CharT>  __facet_type;
 	typedef __locale_cache<numpunct<_CharT> > __cache_type;
 	const locale __loc = __io._M_getloc();
@@ -911,7 +902,7 @@
 	char __fbuf[16];
 
 #ifdef _GLIBCPP_USE_C99
-	// First try a buffer perhaps big enough (for sure sufficient
+	// First try a buffer perhaps big enough (most probably sufficient
 	// for non-ios_base::fixed outputs)
 	int __cs_size = __max_digits * 3;
 	char* __cs = static_cast<char*>(__builtin_alloca(__cs_size));
@@ -933,13 +924,13 @@
 	const bool __fixed = __io.flags() & ios_base::fixed;
 	const int __max_exp = numeric_limits<_ValueT>::max_exponent10;
 
-	// ios_base::fixed outputs may need up to __max_exp+1 chars
-	// for the integer part + up to __max_digits chars for the
-	// fractional part + 3 chars for sign, decimal point, '\0'. On
-	// the other hand, for non-fixed outputs __max_digits*3 chars
-	// are largely sufficient.
-	const int __cs_size = __fixed ? __max_exp + __max_digits + 4 
-	                              : __max_digits * 3;
+	// ios_base::fixed outputs may need up to __max_exp + 1 chars
+	// for the integer part + __prec chars for the fractional part
+	// + 3 chars for sign, decimal point, '\0'. On the other hand,
+	// for non-fixed outputs __max_digits * 2 chars + __prec are
+	// largely sufficient.
+	const int __cs_size = __fixed ? __max_exp + __prec + 4 
+	                              : __max_digits * 2 + __prec;
 	char* __cs = static_cast<char*>(__builtin_alloca(__cs_size));
 
 	_S_format_float(__io, __fbuf, __mod, __prec);
diff -urN gcc-3.3.3.orig/libstdc++-v3/src/Makefile.am gcc-3.3.3/libstdc++-v3/src/Makefile.am
--- gcc-3.3.3.orig/libstdc++-v3/src/Makefile.am	2004-01-12 16:00:30.000000000 -0700
+++ gcc-3.3.3/libstdc++-v3/src/Makefile.am	2004-04-20 02:29:00.000000000 -0600
@@ -225,6 +225,10 @@
 	  @OPT_LDFLAGS@ @SECTION_LDFLAGS@ $(AM_CXXFLAGS) $(LDFLAGS) -o $@
 
 
+install-exec-local:
+	$(AR) cru libstdc++_pic.a .libs/*.o $(top_builddir)/libsupc++/*.o
+	$(INSTALL_DATA) libstdc++_pic.a $(DESTDIR)$(toolexeclibdir)
+
 # Added bits to build debug library.
 if GLIBCPP_BUILD_DEBUG
 all-local: build_debug
diff -urN gcc-3.3.3.orig/libtool.m4 gcc-3.3.3/libtool.m4
--- gcc-3.3.3.orig/libtool.m4	2003-09-09 02:04:17.000000000 -0600
+++ gcc-3.3.3/libtool.m4	2004-04-20 02:29:00.000000000 -0600
@@ -678,7 +678,7 @@
 # This must be Linux ELF.
 linux-gnu*)
   case $host_cpu in
-  alpha* | hppa* | i*86 | powerpc* | sparc* | ia64* )
+  alpha* | hppa* | i*86 | mips | mipsel | powerpc* | sparc* | ia64* )
     lt_cv_deplibs_check_method=pass_all ;;
   *)
     # glibc up to 2.1.1 does not perform some relocations on ARM
diff -urN gcc-3.3.3.orig/ltconfig gcc-3.3.3/ltconfig
--- gcc-3.3.3.orig/ltconfig	2003-02-19 19:10:02.000000000 -0700
+++ gcc-3.3.3/ltconfig	2004-04-20 02:28:59.000000000 -0600
@@ -1577,7 +1577,7 @@
   fi
   ;;
 
-aix4*)
+aix4* | aix5*)
   test "$enable_shared" = yes && enable_static=no
   ;;
 esac
diff -urN gcc-3.3.3.orig/zlib/configure.in gcc-3.3.3/zlib/configure.in
--- gcc-3.3.3.orig/zlib/configure.in	2003-02-20 02:12:20.000000000 -0700
+++ gcc-3.3.3/zlib/configure.in	2004-04-20 02:29:00.000000000 -0600
@@ -123,6 +123,9 @@
 fi
 if test "$GCC" = yes && $CC -print-multi-os-directory > /dev/null 2>&1; then
   multiosdir=/`$CC -print-multi-os-directory`
+  case $multiosdir in
+    /.) multiosdir= ;; # Avoid trailing /.
+  esac
 else
   multiosdir=
 fi
